import React from 'react';
import AccordionContext from './Context';
import { ItemStyle } from './style';
import { Icon } from '../Icon';

var _ref = /*#__PURE__*/React.createElement(Icon, {
  className: "expansion-indicator",
  name: "chevron-up-outline"
});

var _ref2 = /*#__PURE__*/React.createElement(Icon, {
  className: "expansion-indicator",
  name: "chevron-down-outline"
});

export const AccordionItem = ({
  title,
  uniqueKey,
  children
}) => {
  const {
    expanded,
    disabled,
    handleToggle,
    keys,
    setKeys
  } = React.useContext(AccordionContext);
  React.useEffect(() => {
    setKeys([...keys, uniqueKey]);
  }, []);
  const state = {
    expanded: expanded.includes(uniqueKey),
    disabled: disabled.includes(uniqueKey)
  };
  const cssStyle = [];
  state.expanded ? cssStyle.push('expanded') : cssStyle.push('collapsed');
  state.disabled && cssStyle.push('disabled');
  return /*#__PURE__*/React.createElement(ItemStyle, {
    className: cssStyle.join(' ')
  }, /*#__PURE__*/React.createElement("header", {
    onClick: () => handleToggle(uniqueKey)
  }, title, !state.disabled && state.expanded ? _ref : _ref2), /*#__PURE__*/React.createElement("div", {
    className: state.expanded ? 'expanded' : 'collapsed'
  }, /*#__PURE__*/React.createElement("div", {
    className: "item-body"
  }, children)));
};