function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { MessageFileStyle } from './style';
import MessageText from './MessageText';

const FileComponent = props => {
  return /*#__PURE__*/React.createElement("a", {
    href: props.url,
    target: "_blank",
    rel: "noopener noreferrer"
  }, !props.urlStyle && /*#__PURE__*/React.createElement("span", {
    className: props.icon
  }), props.isImage && /*#__PURE__*/React.createElement("div", {
    style: {
      backgroundImage: props.urlStyle
    }
  }));
};

const MessageFile = props => {
  const isImages = file => {
    return !!file.type && ['image/png', 'image/jpeg', 'image/gif'].includes(file.type);
  };

  const readyFiles = props.files ? props.files.map(file => {
    const isImage = isImages(file);
    return { ...file,
      urlStyle: isImage ? `url(${file.url})` : '',
      isImage
    };
  }) : [];
  return /*#__PURE__*/React.createElement(MessageFileStyle, null, /*#__PURE__*/React.createElement(MessageText, {
    sender: props.sender,
    message: props.message,
    date: props.date
  }), readyFiles.length > 1 ? /*#__PURE__*/React.createElement("div", {
    className: "message-content-group"
  }, readyFiles.map((file, index) => /*#__PURE__*/React.createElement(FileComponent, _extends({
    key: index
  }, file)))) : readyFiles.length === 1 && /*#__PURE__*/React.createElement(FileComponent, readyFiles[0]));
};

export default MessageFile;