/*
 * @license
 * Copyright Ahmed Elywa. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */
import React from 'react';
import styled, { css } from 'styled-components';
import { maxContainer, breakpointUp, getGridGutter } from '@paljs/theme';
const width = css`
  ${({
  fluid
}) => !fluid && Object.keys(maxContainer).map(key => breakpointUp(key)`
        max-width: ${maxContainer[key]}px;
      `)}
`;
const ContainerStyle = styled.div`
  margin-right: auto;
  margin-left: auto;
  width: 100%;
  ${({
  theme
}) => css`
    padding-right: ${getGridGutter(theme) / 2}px;
    padding-left: ${getGridGutter(theme) / 2}px;
  `}
  ${width}
`;

const Container = props => /*#__PURE__*/React.createElement(ContainerStyle, props, props.children);

export default Container;