function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

/*
 * @license
 * Copyright Ahmed Elywa. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */
import React from 'react';
import { Icon, ItemIcon } from '../Icon';
import { ItemStyle } from './style';

const LinkContent = ({
  item
}) => {
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(ItemIcon, {
    icon: item.icon,
    className: "menu-icon"
  }), /*#__PURE__*/React.createElement("span", {
    className: "menu-title"
  }, item.title));
};

var _ref = /*#__PURE__*/React.createElement(Icon, {
  name: "chevron-down-outline"
});

var _ref2 = /*#__PURE__*/React.createElement(Icon, {
  name: "chevron-left-outline"
});

const Item = ({
  item,
  toggleSidebar,
  toggleSubMenu,
  selectItem,
  id,
  Link,
  nextJs,
  currentPath
}) => {
  React.useEffect(() => {
    const link = nextJs ? item.link?.href : item.link?.to;
    if (link && (currentPath === link || item.hasDynamicPath && currentPath?.startsWith(link)) && !item.selected) selectItem(id);
  }, [currentPath]);

  const onClickHandler = () => {
    !item.selected && selectItem(id);
    toggleSidebar && toggleSidebar();
  };

  const handleToggleSubMenu = () => {
    toggleSubMenu(item);
  };

  return /*#__PURE__*/React.createElement(ItemStyle, {
    className: item.group ? 'menu-item menu-group' : 'menu-item'
  }, item.group ? /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(ItemIcon, {
    icon: item.icon,
    className: "menu-icon"
  }), item.title) : item.link && !item.children ? nextJs ? /*#__PURE__*/React.createElement(Link, item.link, /*#__PURE__*/React.createElement("a", {
    onClick: onClickHandler,
    className: item.selected ? 'active' : ''
  }, /*#__PURE__*/React.createElement(LinkContent, {
    item: item
  }))) : /*#__PURE__*/React.createElement(Link, _extends({}, item.link, {
    className: item.selected ? 'active' : '',
    onClick: onClickHandler
  }), /*#__PURE__*/React.createElement(LinkContent, {
    item: item
  })) : item.url && !item.children ? /*#__PURE__*/React.createElement("a", {
    href: item.url
  }, /*#__PURE__*/React.createElement(LinkContent, {
    item: item
  })) : item.children ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("a", {
    href: "#",
    title: item.title,
    onClick: e => {
      e.preventDefault();
      handleToggleSubMenu();
    },
    className: item.selected ? 'active' : ''
  }, /*#__PURE__*/React.createElement(ItemIcon, {
    icon: item.icon,
    className: "menu-icon"
  }), /*#__PURE__*/React.createElement("span", {
    className: "menu-title"
  }, item.title), /*#__PURE__*/React.createElement("i", {
    className: "chevron"
  }, item.expanded ? _ref : _ref2)), /*#__PURE__*/React.createElement("ul", {
    className: item.expanded ? 'menu-items expanded' : 'menu-items collapsed'
  }, item.children.map((item2, index) => {
    return !item.hidden && /*#__PURE__*/React.createElement(Item, {
      key: index,
      item: item2,
      id: id.concat([index]),
      Link: Link,
      nextJs: nextJs,
      currentPath: currentPath,
      selectItem: selectItem,
      toggleSidebar: toggleSidebar,
      toggleSubMenu: toggleSubMenu
    });
  }))) : '');
};

export default Item;