import React from 'react';
import Overlay from '../Overlay';
import styled from 'styled-components';
export const Modal = props => {
  if (!props.on) return /*#__PURE__*/React.createElement(React.Fragment, null);
  return /*#__PURE__*/React.createElement(Overlay, null, /*#__PURE__*/React.createElement(StyledModal, null, /*#__PURE__*/React.createElement(Background, {
    onClick: props.toggle
  }), /*#__PURE__*/React.createElement(Content, null, props.children)));
};
const StyledModal = styled.div`
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  display: flex;
  justify-content: center;
  align-items: center;
`;
const Background = styled.div`
  position: absolute;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  opacity: 0.6;
  background-color: black;
`;
const Content = styled.div`
  position: relative;
  z-index: 2;
  max-width: 100%;
  max-height: 100%;
`;