function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

/* eslint-disable @typescript-eslint/no-empty-function */

/*
 * @license
 * Copyright Ahmed Elywa. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */
import ReactDOM from 'react-dom';
import React from 'react';
import usePopoverPosition from '../utils/popoverPosition';
import { OverlayStyle } from './style';
const initialContext = {
  positionHandle() {},

  hide() {}

};
export const OverLayContext = /*#__PURE__*/React.createContext(initialContext);

const Overlay = props => {
  const overlayRef = React.useRef(null);
  const targetRef = React.useRef(null);
  const {
    position,
    placement,
    show,
    setShow,
    positionHandle
  } = usePopoverPosition(props, targetRef, overlayRef);
  let timeOut;

  const onMouseLeave = () => {
    timeOut = setTimeout(() => {
      setShow(false);
    }, 500);
  };

  const onMouseEnter = () => {
    clearTimeout(timeOut);
  };

  const {
    trigger,
    transformSize
  } = props;
  const overlayMouse = props.contextMenu ? {} : {
    onMouseEnter: () => trigger === 'hover' && onMouseEnter(),
    onMouseLeave: () => trigger === 'hover' && onMouseLeave()
  };
  const targetMouse = props.contextMenu ? {
    onClick: e => {
      e.stopPropagation();
      setShow(!show);
    }
  } : {
    onFocus: () => trigger === 'focus' && setShow(true),
    onBlur: () => trigger === 'focus' && setShow(false),
    onClick: e => {
      e.stopPropagation();
      trigger === 'click' && setShow(!show);
    },
    onMouseEnter: () => trigger === 'hint' ? setShow(true) : trigger === 'hover' && !show ? setShow(true) : trigger === 'hover' && onMouseEnter(),
    onMouseLeave: () => {
      trigger === 'hint' ? setShow(false) : trigger === 'hover' && onMouseLeave();
    }
  };
  return /*#__PURE__*/React.createElement(React.Fragment, null, show && /*#__PURE__*/ReactDOM.createPortal( /*#__PURE__*/React.createElement(OverlayStyle, {
    position: !!position,
    placement: placement,
    size: transformSize,
    arrowRound: props.arrowRound,
    arrowSize: props.arrowSize
  }, /*#__PURE__*/React.createElement(OverLayContext.Provider, {
    value: {
      positionHandle,
      hide: () => setShow(false)
    }
  }, /*#__PURE__*/React.createElement("div", _extends({
    className: "overlay-pane",
    style: position && {
      top: position.top,
      left: position.left
    },
    ref: overlayRef,
    onClick: e => e.stopPropagation()
  }, overlayMouse), props.children))), document.getElementById('overlay-container')), /*#__PURE__*/React.createElement("div", _extends({
    style: props.style,
    className: props.className,
    ref: targetRef
  }, targetMouse), props.target));
};

export default Overlay;