import styled, { css } from 'styled-components';
import React from 'react';
const ProgressStyle = styled.div`
  ${({
  theme,
  size,
  status,
  value
}) => css`
    display: block;
    .progress-container {
      overflow: hidden;
      border-radius: ${theme.progressBarBorderRadius};
    }
    .progress-value {
      height: 100%;
      width: ${value}%;
      text-align: center;
      overflow: hidden;
      display: flex;
      align-items: center;
      justify-content: center;
      font-family: ${theme.progressBarTextFontFamily};
      transition-duration: ${theme.progressBarAnimationDuration};
      transition-property: width, background-color;
    }
    ${size && css`
      .progress-container {
        height: ${theme[`progressBar${size}Height`]};
      }

      .progress-value {
        font-size: ${theme[`progressBar${size}TextFontSize`]};
        font-weight: ${theme[`progressBar${size}TextFontWeight`]};
        line-height: ${theme[`progressBar${size}TextLineHeight`]};
      }
    `}
    ${status && css`
      .progress-container {
        background-color: ${theme[`progressBar${status}BackgroundColor`]};
      }

      .progress-value {
        background-color: ${theme[`progressBar${status}FilledBackgroundColor`]};
        color: ${theme[`progressBar${status}TextColor`]};
      }
    `}
  `}
`;

const Progress = props => {
  return /*#__PURE__*/React.createElement(ProgressStyle, props, /*#__PURE__*/React.createElement("div", {
    className: "progress-container"
  }, /*#__PURE__*/React.createElement("div", {
    className: "progress-value"
  }, props.displayValue && /*#__PURE__*/React.createElement("span", null, props.value, "%"), props.children)));
};

Progress.defaultProps = {
  size: 'Medium',
  status: 'Basic',
  value: 0
};
export default Progress;