/*
 * @license
 * Copyright Ahmed Elywa. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */
import React from 'react';
import RadioStyle from './style';

var _ref = /*#__PURE__*/React.createElement("span", {
  className: "outer-circle"
});

var _ref2 = /*#__PURE__*/React.createElement("span", {
  className: "inner-circle"
});

export const Radio = props => {
  const [options, setOptions] = React.useState(props.options);

  const onClickHandler = value => {
    const updateOptions = [...options];

    for (const option of updateOptions) {
      option.checked = option.value === value;
    }

    setOptions(updateOptions);
    props.onChange(value);
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, options.map(option => /*#__PURE__*/React.createElement(RadioStyle, {
    status: option.status ?? 'Basic',
    key: option.value,
    className: props.className
  }, /*#__PURE__*/React.createElement("label", null, /*#__PURE__*/React.createElement("input", {
    type: "radio",
    checked: option.checked,
    name: props.name,
    disabled: option.disabled || props.disabled,
    onClick: () => onClickHandler(option.value),
    className: "native-input visually-hidden"
  }), _ref, _ref2, /*#__PURE__*/React.createElement("span", {
    className: "text"
  }, option.label)))));
};