function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import ReactDOM from 'react-dom';
import React from 'react';
import layoutContext from '../Layout/layout-context';
import { ToastrStyle } from './style';
import { isRightPosition } from '../utils/positionHelper';
import { ItemIcon } from '../Icon';

const Item = props => {
  const [show, setShow] = React.useState(true);
  const [animation, setAnimation] = React.useState('animation');
  const layout = React.useContext(layoutContext);

  const destroyItem = () => {
    setAnimation('animation');
    setTimeout(() => {
      setShow(false);
    }, 100);
  };

  const onClick = () => {
    if (props.destroyByClick) {
      destroyItem();
    }
  };

  React.useEffect(() => {
    if (props?.duration > 0) {
      setTimeout(() => {
        destroyItem();
      }, props.duration);
    }

    if (animation === 'animation') {
      setTimeout(() => {
        setAnimation('');
      }, 10);
    }
  }, []);
  return show ? /*#__PURE__*/ReactDOM.createPortal( /*#__PURE__*/React.createElement(ToastrStyle, _extends({
    isRight: isRightPosition(layout.dir ?? 'ltr', props.position),
    className: animation,
    onClick: onClick
  }, props), props.icon && props.hasIcon && /*#__PURE__*/React.createElement(ItemIcon, {
    icon: props.icon,
    className: "icon"
  }), /*#__PURE__*/React.createElement("div", {
    className: "content-container"
  }, props.title && /*#__PURE__*/React.createElement("span", {
    className: "title"
  }, props.title), /*#__PURE__*/React.createElement("div", {
    className: "message"
  }, props.message))), document.getElementById('toastr' + props.position)) : /*#__PURE__*/React.createElement(React.Fragment, null);
};

export default Item;