function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import ReactDOM from 'react-dom';
import React from 'react';
import layoutContext from '../Layout/layout-context';
import { getLogicalPosition } from '../utils/positionHelper';
import { ToastrContainer } from './style';
import Item from './Item';
const Toastr = /*#__PURE__*/React.forwardRef((props, ref) => {
  const [items, setItems] = React.useState([]);
  const [createParents, setCreateParents] = React.useState(false);
  const layout = React.useContext(layoutContext);
  React.useEffect(() => {
    setCreateParents(true);
  }, []);
  React.useImperativeHandle(ref, () => ({
    add(message, title = '', option = {}) {
      const options = { ...props,
        ...option
      };
      const newItems = [...items];
      let push = true;

      if (options.preventDuplicates) {
        for (const item of newItems) {
          if (item.title === title && item.message === message) {
            push = false;
          }
        }
      }

      if (push) {
        options.position = getLogicalPosition(layout.dir ?? 'ltr', options.position);
        newItems.push({ ...options,
          title,
          message,
          icon: options.icons ? options.icons[options.status] : ''
        });
        setItems(newItems);
      }
    }

  }), [items]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, createParents && ['topStart', 'topEnd', 'bottomStart', 'bottomEnd'].map(position => /*#__PURE__*/ReactDOM.createPortal( /*#__PURE__*/React.createElement(ToastrContainer, {
    position: position,
    isTop: position === 'topEnd' || position === 'topStart'
  }, /*#__PURE__*/React.createElement("div", {
    className: "overlay-pane",
    id: 'toastr' + position
  })), document.getElementById('overlay-container'))), items.map((item, index) => /*#__PURE__*/React.createElement(Item, _extends({
    key: index
  }, item))));
});
Toastr.displayName = 'Toastr';
Toastr.defaultProps = {
  position: 'topEnd',
  status: 'Primary',
  duration: 3000,
  hasIcon: true,
  destroyByClick: true,
  preventDuplicates: false,
  icons: {
    Danger: 'flash-outline',
    Success: 'checkmark-outline',
    Info: 'question-mark-outline',
    Warning: 'alert-triangle-outline',
    Primary: 'email-outline',
    Control: 'email-outline',
    Basic: 'email-outline'
  }
};
export { Toastr };