import React from 'react';
import { Placement } from '../types';
export interface Position {
    top: number;
    bottom?: number;
    right?: number;
    left: number;
}
export declare type PositionKeys = keyof Position;
interface Props {
    placement: Placement;
    eventListener?: string;
}
export default function usePopoverPosition(props: Props, targetRef: React.RefObject<HTMLDivElement>, overlayRef: React.RefObject<HTMLDivElement>): {
    position: Position | undefined;
    placement: "left" | "right" | "top" | "bottom";
    show: boolean;
    setShow: React.Dispatch<React.SetStateAction<boolean>>;
    positionHandle: () => void;
};
export {};
//# sourceMappingURL=popoverPosition.d.ts.map